#include <proto/dos.h>
#include <proto/locale.h>
#include "locale_intern.h"

#undef SysBase
#undef DOSBase
extern struct ExecBase *SysBase;
extern struct DosLibrary *DOSBase;

/* Check for timezone prefs if any - this is a silly workaround to
   mitigate the issue where IPrefs is not yet running - there are no
   realtime updates by TZ change then, but it's better than nothing.
   - Piru
*/
VOID TZCheckSysTimeZone(struct Library *LocaleBase)
{
  struct Task *self;
  UBYTE buf[256];

  /* This thing could get called before install_timezone_patches has
     been ran. Thus we need to make sure that the global bases are
     set up. - Piru
   */
  SysBase = ((struct IntLocaleBase *)LocaleBase)->lb_SysBase;
  DOSBase = ((struct IntLocaleBase *)LocaleBase)->lb_DosBase;
#define SysBase (((struct IntLocaleBase *)LocaleBase)->lb_SysBase)
#define DOSBase (((struct IntLocaleBase *)LocaleBase)->lb_DosBase)

  self = FindTask(NULL);

  if (self->tc_Node.ln_Type == NT_PROCESS &&
      GetVar("TZ", buf, sizeof(buf), LV_VAR | GVF_GLOBAL_ONLY) > 0)
  {
    TZSetSysTimeZone(buf);
  }
}

